<ui:composition xmlns="http://www.w3.org/1999/xhtml"
                xmlns:s="http://jboss.org/schema/seam/taglib"
                xmlns:ui="http://java.sun.com/jsf/facelets"
                xmlns:a4j="http://richfaces.org/a4j"
                xmlns:g="http://www.ihe.net/gazelle"
                xmlns:h="http://java.sun.com/jsf/html"
                xmlns:f="http://java.sun.com/jsf/core"
                template="/layout/template.xhtml">
    <ui:define name="body">
        <h1>
            <h:outputText value="#{messages['gazelle.simulator.pam.AllPatients']}"
                          rendered="#{not patientManager.filterOnConnectathonOnly}"/>
            <h:outputText value="#{messages['gazelle.PAMSimulator.ConnectathonDemographicsToPreload']}"
                          rendered="#{patientManager.filterOnConnectathonOnly}"/>
        </h1>
        <h:form id="globalForm">
            <!--<s:token allowMultiplePosts="true"/>-->
            <a4j:queue requestDelay="300" ignoreDupResponses="true"/>
            <h:inputHidden id="filterUrlParameters" name="filterUrlParameters"
                           value="#{patientManager.filter.urlParameters}"/>
            <script>
                updateUrl("globalForm:filterUrlParameters");
                jq162("#globalForm\\:filterUrlParameters").bind('change',
                    function () {
                        updateUrl("globalForm:filterUrlParameters");
                    });

            </script>
            <ui:decorate template="/layout/panels/_panel_filter_criteria.xhtml">
                <div class="row">
                    <div class="col-md-4">
                        <ui:include src="/filter/filter.xhtml">
                            <ui:param name="filterWidth" value="240"/>
                            <ui:param name="filter" value="#{patientManager.filter}"/>
                            <ui:param name="filterId" value="lastname"/>
                            <ui:param name="filterName" value="#{messages['gazelle.pam.LastName']}"/>
                            <ui:param name="filterForm" value="globalForm"/>
                        </ui:include>
                    </div>
                    <div class="col-md-4">
                        <ui:include src="/filter/filter.xhtml">
                            <ui:param name="filterWidth" value="240"/>
                            <ui:param name="filter" value="#{patientManager.filter}"/>
                            <ui:param name="filterId" value="firstname"/>
                            <ui:param name="filterName" value="#{messages['gazelle.pam.FirstName']}"/>
                            <ui:param name="filterForm" value="globalForm"/>
                        </ui:include>
                    </div>
                    <div class="col-md-4">
                        <ui:include src="/filter/filter.xhtml">
                            <ui:param name="filterWidth" value="240"/>
                            <ui:param name="filter" value="#{patientManager.filter}"/>
                            <ui:param name="filterId" value="gender"/>
                            <ui:param name="filterName"
                                      value="#{messages['gazelle.simulator.PatientGeneration.Gender']}"/>
                            <ui:param name="filterForm" value="globalForm"/>
                        </ui:include>
                    </div>
                </div>
                <div class="row">
                    <div class="col-md-4">
                        <f:subview rendered="#{not patientManager.isEPD()}">
                            <ui:include src="/filter/filter.xhtml">
                                <ui:param name="filterWidth" value="240"/>
                                <ui:param name="filter" value="#{patientManager.filter}"/>
                                <ui:param name="filterId" value="mothersmaidenname"/>
                                <ui:param name="filterName" value="#{messages['gazelle.simulator.pam.MothersMaidenName']}"/>
                                <ui:param name="filterForm" value="globalForm"/>
                            </ui:include>
                        </f:subview>
                    </div>
                    <div class="col-md-4">
                        <ui:include src="/filter/filter.xhtml">
                            <ui:param name="filterWidth" value="240"/>
                            <ui:param name="filter" value="#{patientManager.filter}"/>
                            <ui:param name="filterId" value="country"/>
                            <ui:param name="filterName"
                                      value="#{messages['gazelle.simulator.PatientGeneration.Country']}"/>
                            <ui:param name="filterForm" value="globalForm"/>
                        </ui:include>
                    </div>
                    <div class="col-md-4">
                        <ui:include src="/filter/filter.xhtml">
                            <ui:param name="filterWidth" value="240"/>
                            <ui:param name="filter" value="#{patientManager.filter}"/>
                            <ui:param name="filterId" value="owner"/>
                            <ui:param name="filterName" value="#{messages['gazelle.HL7Common.Owner']}"/>
                            <ui:param name="filterForm" value="globalForm"/>
                        </ui:include>
                    </div>
                </div>
                <div class="row">
                    <div class="col-md-4 gzl-never-wrap">
                        <h:panelGroup>
                            <ui:decorate template="/layout/form/_form_field_horizontal_4-8.xhtml">
                                <ui:param name="id" value="idInput"/>
                                <ui:define name="label">#{messages['gazelle.pam.Identifier']}</ui:define>
                                <h:inputText id="idInput" value="#{patientManager.searchedPatientId}"
                                             styleClass="form-control" style="width:90%;">
                                    <a4j:ajax event="keyup" render="globalForm"/>
                                </h:inputText>
                            </ui:decorate>
                            <a4j:commandLink event="click" actionListener="#{patientManager.setSearchedPatientId(null)}"
                                             render="globalForm" execute="@this">
                                <span class="gzl-icon-times"/>
                            </a4j:commandLink>
                        </h:panelGroup>
                    </div>
                    <div class="col-md-4 gzl-never-wrap">
                        <h:panelGroup>
                            <ui:decorate template="/layout/form/_form_field_horizontal_4-8.xhtml">
                                <ui:param name="id" value="relInput"/>
                                <ui:define name="label">#{messages['net.ihe.gazelle.patientmanager.RelationshipsLastName']}</ui:define>
                                <h:inputText id="relInput" value="#{patientManager.relationshipLastName}"
                                             styleClass="form-control" style="width:90%;">
                                    <a4j:ajax event="keyup" render="globalForm"/>
                                </h:inputText>
                            </ui:decorate>
                            <a4j:commandLink event="click" actionListener="#{patientManager.setRelationshipLastName(null)}"
                                             render="globalForm" execute="@this">
                                <span class="gzl-icon-times"/>
                            </a4j:commandLink>
                        </h:panelGroup>
                    </div>
                    <div class="col-md-offset-1 col-md-3">
                        <f:subview rendered="#{not patientManager.filterOnConnectathonOnly}">
                            <s:decorate template="/layout/form/_checkbox.xhtml">
                                <h:selectBooleanCheckbox value="#{patientManager.onlyActivePatients}">
                                    <a4j:ajax event="change" render="globalForm"/>
                                </h:selectBooleanCheckbox>
                                <h:outputText value="#{messages['gazelle.PAMSimulator.ActivePatientsOnly']}"/>
                            </s:decorate>
                        </f:subview>
                    </div>
                </div>
                <s:div styleClass="row" rendered="#{not patientManager.filterOnConnectathonOnly}">
                    <div class="col-md-4">
                        <ui:include src="/filter/filter.xhtml">
                            <ui:param name="filterWidth" value="240"/>
                            <ui:param name="filter" value="#{patientManager.filter}"/>
                            <ui:param name="filterId" value="actor"/>
                            <ui:param name="filterName" value="#{messages['gazelle.HL7Common.simulatedActor']}"/>
                            <ui:param name="filterForm" value="globalForm"/>
                        </ui:include>
                    </div>
                    <div class="col-md-8"></div>
                </s:div>
                <ui:define name="filter_buttons">
                    <a4j:commandLink title="#{messages['gazelle.pam.RefreshResults']}"
                                     render="globalForm">
                        <span class="gzl-icon-refresh"/>
                    </a4j:commandLink>
                    <a4j:commandLink title="#{messages['gazelle.pam.ResetCriteria']}"
                                     actionListener="#{patientManager.reset()}"
                                     render="globalForm">
                        <span class="gzl-icon-times-circle"/>
                    </a4j:commandLink>
                </ui:define>
            </ui:decorate>
            <ui:decorate template="/patient/_patientTable.xhtml">
                <ui:define name="firstcolumn">
                    <g:column>
                        <s:span styleClass="fa fa-archive" rendered="#{not patient.stillActive}"
                                title="Patient cannot be used anymore"/>
                    </g:column>
                </ui:define>
                <ui:param name="patients" value="#{patientManager.getPatients()}"/>
                <ui:define name="rightColumns">
                    <g:column>
                        <f:facet name="header">#{messages['gazelle.pam.Actions']}
                            <a4j:commandLink title="#{messages['net.ihe.gazelle.patientmanager.DeactivateSelectedPatients']}"
                                             actionListener="#{patientManager.deactivateSelectedPatients()}"
                                             render="patientsListTable"
                                             rendered="#{s:hasRole('admin_role')}">
                                <s:span styleClass="gzl-icon-ban gzl-text-red"/>
                            </a4j:commandLink>
                            <a4j:commandLink title="#{messages['net.ihe.gazelle.patientmanager.ActivateSelectedPatients']}"
                                             actionListener="#{patientManager.activateSelectedPatients()}"
                                             render="patientsListTable"
                                             rendered="#{s:hasRole('admin_role')}">
                                <s:span styleClass="gzl-icon-undo"/>
                            </a4j:commandLink>
                            <a4j:commandLink rendered="#{patientManager.filterOnConnectathonOnly}"
                                             action="#{patientManager.shareSelectedPatients()}"
                                             title="#{messages['gazelle.PAMSimulator.SendSelectedPatientsToSUTs']}">
                                <span class="gzl-icon-stack">
                                    <span class="gzl-icon-user gzl-icon-stack-1x"/>
                                    <span class="gzl-icon-share-alt gzl-icon-stack-1x gzl-icon-stack-bottom-right  gzl-color-light-green"/>
                                </span>
                            </a4j:commandLink>
                            <h:commandLink actionListener="#{patientManager.getSelectedPatientsAsFHIR()}"
                                           title="#{messages['gazelle.PAMSimulator.DownloadAsFHIRResource']}"
                                           rendered="#{patientManager.filterOnConnectathonOnly}">
                                <s:span styleClass="gzl-icon-download"/>
                            </h:commandLink>
                        </f:facet>
                        <div class="gzl-never-wrap">
                            <h:outputLink value="#{patient.getPermanentLink()}"
                                          title="#{messages['gazelle.pam.AccessDetails']}" target="blank">
                                <s:span styleClass="gzl-icon-search "/>
                            </h:outputLink>
                            <h:commandLink actionListener="#{patientManager.getFhirResource(patient)}"
                                           rendered="#{patientManager.filterOnConnectathonOnly}"
                                           title="#{messages['gazelle.PAMSimulator.DownloadAsFHIRResource']}">
                                <s:span styleClass="gzl-icon-download"/>
                            </h:commandLink>
                            <a4j:commandLink action="#{patientManager.redirectToWorklistPage(patient)}"
                                             rendered="#{patientManager.isWorklistFeatureEnabled()}"
                                             title="#{messages['gazelle.pam.CreateAWorklist']}">
                                <s:span styleClass="gzl-icon-list "/>
                            </a4j:commandLink>
                            <a4j:commandLink actionListener="#{patient.deactivatePatient()}"
                                             render="patientsListTable" title="#{messages['net.ihe.gazelle.patientmanager.DeactivatePatient']}"
                                             rendered="#{s:hasRole('admin_role') and patient.stillActive}">
                                <s:span styleClass="gzl-icon-ban gzl-text-red"/>
                            </a4j:commandLink>
                            <a4j:commandLink actionListener="#{patient.activatePatient()}"
                                             render="patientsListTable" title="#{messages['net.ihe.gazelle.patientmanager.ActivatePatient']}"
                                             rendered="#{s:hasRole('admin_role') and not patient.stillActive}">
                                <s:span styleClass="gzl-icon-undo"/>
                            </a4j:commandLink>
                            <a4j:commandLink rendered="#{patientManager.filterOnConnectathonOnly}"
                                             action="#{patientManager.shareSinglePatient(patient)}"
                                             title="#{messages['gazelle.PAMSimulator.SendThisPatientToSUTs']}">
                                <span class="gzl-icon-stack">
                                    <span class="gzl-icon-user gzl-icon-stack-1x"/>
                                    <span class="gzl-icon-share-alt gzl-icon-stack-1x gzl-icon-stack-bottom-right  gzl-color-light-green"/>
                                </span>
                            </a4j:commandLink>
                            <a4j:commandLink rendered="#{s:hasRole('admin_role') and patientManager.filterOnConnectathonOnly}"
                                             action="#{patientManager.editPatient(patient)}"
                                             title="#{messages['gazelle.PAMSimulator.EditPatient']}">
                                <s:span styleClass="gzl-icon-pencil"/>
                            </a4j:commandLink>
                        </div>
                    </g:column>
                </ui:define>
            </ui:decorate>
        </h:form>
    </ui:define>
</ui:composition>
